SystemOrganization addCategory: #'CS528-UT3Server'!

WAComponent subclass: #UT3WebServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Server'!

!UT3WebServer commentStamp: '<historical>' prior: 0!
An UT3WebServer is a component that holds everything to do with the web server to play the game.

Instance Variables
!

UT3WebServer subclass: #UT3GameSession
	instanceVariableNames: 'system row column subrow subcolumn ssubrow ssubcolumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Server'!

!UT3GameSession commentStamp: '<historical>' prior: 0!
An UT3GameSession is a web component holding a session of a game (ie a System).

Instance Variables
	system:		<Object>

system
	- xxxxx
!

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:38'!
column
	^ column asString! !

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:39'!
column: aColumn
	column := aColumn asInteger! !

!UT3GameSession methodsFor: 'initialization' stamp: 'Oliver 7/5/2013 21:28'!
initialize
	super initialize.
	system := UT3System new.
	row := 1.
	column := 1.
	subrow := 1.
	subcolumn := 1.
	ssubrow := 1.
	ssubcolumn := 1! !

!UT3GameSession methodsFor: 'initialization' stamp: 'Oliver 7/5/2013 21:34'!
makeMove
	system currentGameType = #basic
	ifTrue: [ system player: system currentPlayer moveRow: row column: column ]
	ifFalse: [ 
		system currentGameType = #ultimate
		ifTrue: [ system player: system currentPlayer moveAt: { row. column } subBoard: { subrow. subcolumn }  ]
		ifFalse: [ 
			system currentGameType = #double_ultimate
			ifTrue: [ system player: system currentPlayer moveAt: { row. column } subBoard: { subrow. subcolumn } ssubBoard: { ssubrow. ssubcolumn } ]
		]
	]! !

!UT3GameSession methodsFor: 'initialization' stamp: 'JonathanOsting 7/6/2013 06:40'!
renderContentOn: html
	(((system currentGameType) = #basic) or: ((system currentGameType) = #ultimate))
	ifTrue: [ self renderSystemOn: html ]
	ifFalse: [
	system printString do: [ :char | 
		char = Character cr
		ifTrue: [ html break ]
		ifFalse: [ html text: char asString ] ].
	Transcript show: system printString.
	
	html break.
	html text: 'Move for Player '; text: system currentPlayer printString; break.
	html form: [ 
		html text: 'Row: '. html textInput on: #row of: self.
		html text: '  Column: '. html textInput on: #column of: self.
		system currentGameType = #ultimate
		ifTrue: [ 
			html text: '  Subrow: '. html textInput on: #subrow of: self.
			html text: '  Subcolumn: '. html textInput on: #subcolumn of: self.
		]
		ifFalse:[
			system currentGameType = #double_ultimate
			ifTrue: [ 
				html text: '  Subrow: '. html textInput on: #subrow of: self.
				html text: '  Subcolumn: '. html textInput on: #subcolumn of: self.
				html text: '  SubSubrow: '. html textInput on: #ssubrow of: self.
				html text: '  SubSubcolumn: '. html textInput on: #ssubcolumn of: self.
			]	
		].
		html submitButton text: 'Move'; callback: [ self makeMove ].
	].
	].
	html break.
	html text: 'Reset game session: '; break.
	html form: [ 
		html select list: system gameTypes;
			on: #currentGameType of: system.
		html submitButton text: 'Go' ].! !

!UT3GameSession methodsFor: 'initialization' stamp: 'JonathanOsting 7/6/2013 08:13'!
renderSystemOn: html
	| board subboard cell canMove boardUndecided subboardUndecided |
	board := (system board).
	html text: 'Current Game Type: '.
	html text: (system currentGameType printString).
	html break; text: 'Current player: '.
	html text: (system currentPlayer printString).
	html break; text: 'Current board state: '.
	html text: (board winner printString).
	html break.
	" render the board"

	system currentGameType = #basic
	ifTrue: [ 
		board indicesDo: [ :aRow :aCol | 
			cell := board atRow: aRow column: aCol.
			(((cell state) = #empty) and: ((board winner) = #undecided	))
			ifTrue:	[ html anchor callback: [row := aRow.  column := aCol. self makeMove]; with: (cell printString) ]
			ifFalse: [ html text: (cell printString) ].
			
			aCol = board size
			ifTrue: [ html text: '|'; break.] 
			ifFalse: [ html text: '|' ]
		] ].
	system currentGameType = #ultimate
	ifTrue: [ subboard := board at: 1 at: 1.
				(1 to: board size) do: [ :aRow |
			 	(1 to: subboard size) do: [ :sRow |
				(1 to: board size) do: [ :aCol |	
				(1 to: subboard size) do: [ :sCol |
					subboard := board at: aRow at: aCol.
					cell := subboard atRow: sRow column: sCol.
					canMove := board canMoveAt: {aRow . aCol} subBoard: {sRow . sCol}.
					boardUndecided := (board winner) = #undecided.
					subboardUndecided := (subboard winner) = #undecided.
					((canMove and: boardUndecided) and: subboardUndecided)
					ifTrue:	[ html anchor 
							  		callback: [row := aRow. 
											   column := aCol. 
											   subrow := sRow. 
											   subcolumn := sCol. 
											   self makeMove];
									with: (cell printString) ]
						ifFalse: [ html text: (cell printString) ].
				sCol = (subboard size)
				ifTrue: [ html text: ' || '.
						aCol = (board size) 
						ifTrue: [ html break.
							sRow = (subboard size)
							ifTrue: [ html break ] ] ]
				ifFalse: [ html text: '|'  ] ] ] ] ] ].! !

!UT3GameSession methodsFor: 'initialization' stamp: 'ShineLow 7/4/2013 20:09'!
reset: aString 
	system resetWithGameType: aString asSymbol ! !

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:38'!
row
	^ row asString! !

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:39'!
row: aRow
	row := aRow asInteger! !

!UT3GameSession methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 21:26'!
ssubcolumn
	^ ssubcolumn asString! !

!UT3GameSession methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 21:26'!
ssubcolumn: aSubrow
	ssubcolumn := aSubrow asInteger! !

!UT3GameSession methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 21:25'!
ssubrow
	^ ssubrow asString! !

!UT3GameSession methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 21:25'!
ssubrow: aSubrow
	ssubrow := aSubrow asInteger! !

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:38'!
subcolumn
	^ subcolumn asString! !

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:38'!
subcolumn: aSubcolumn
	subcolumn := aSubcolumn asInteger! !

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:38'!
subrow
	^ subrow asString! !

!UT3GameSession methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:38'!
subrow: aSubrow
	subrow := aSubrow asInteger! !

UT3WebServer subclass: #UT3WebBase
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Server'!

!UT3WebBase commentStamp: '<historical>' prior: 0!
An UT3WebBase is base page containing all the web components of the game.

Instance Variables
	modeSelector:		<Object>

modeSelector
	- xxxxx
!

!UT3WebBase class methodsFor: 'testing' stamp: 'ShineLow 7/4/2013 19:54'!
canBeRoot
	^ true! !

!UT3WebBase class methodsFor: 'class initialization' stamp: 'ShineLow 7/4/2013 19:54'!
initialize
	super initialize.
	self registerAsApplication: 'Tic Tac Toe app'! !

!UT3WebBase methodsFor: 'hooks' stamp: 'ShineLow 7/4/2013 19:44'!
children
	^ { session }! !

!UT3WebBase methodsFor: 'initialization' stamp: 'ShineLow 7/4/2013 19:44'!
initialize 	
	super initialize.
	session := UT3GameSession new.! !

!UT3WebBase methodsFor: 'rendering' stamp: 'ShineLow 7/4/2013 19:43'!
renderContentOn: html
	html heading: 'Welcome to Ultimate Tic-Tac-Toe!!'.
	self children do: [ :each | html div class: 'subcomponent'; with: each ]! !

!UT3WebServer methodsFor: 'hooks' stamp: 'ShineLow 7/4/2013 15:26'!
style
	^ 'body {
	font: 10pt Arial, Helvetica, sans-serif, Times New Roman;
}
h2 {
	font-size: 12pt;
	font-weight: normal;
	font-style: italic;
}
table {
	border-collapse: collapse;
}
td {
	border: 2px solid #CCCCCC;
	padding: 4px;
}
#author {
	border: 1px solid black;
	padding: 2px;
	margin: 2px;
}
.subcomponent {
	border: 2px solid lightblue;
	padding: 2px;
	margin: 2px;
}
.highlight {
	background-color: yellow;
}
.boolean {
	background-color: lightgrey;
}
.field {
	background-color: lightgrey;
}'! !
UT3WebBase initialize!
